﻿Imports TechNote40_ImageRotation_VB.My.Resources

Public Class Form1

    ' -------------------- Point Rotation 관련 변수 --------------------
    ' 선 또는 도형의 중심축을 기준으로 회전하는 각도
    Private m_dbPointAngle1 As Double = 90
    Private m_dbPointAngle2 As Double = 120
    Private m_dbPointAngle3 As Double = -90
    Private m_dbPointAngle4 As Double = -90

    ' 선 또는 도형의 좌표를 저장하는 배열
    Private m_Needle1 As Point()
    Private m_Needle2_1 As Point()
    Private m_Needle2_2 As Point()
    Private m_Needle3 As Point()
    Private m_Needle4 As Point()

    ' 선 또는 도형의 중심축1(좌표) 저장
    Private m_NeedleCenter1 As Point
    Private m_NeedleCenter2 As Point
    Private m_NeedleCenter3 As Point

    ' -------------------- Image Rotation 관련 변수 --------------------
    ' 첫번째 회전체의 각도
    Private m_ImageAngle4 As Double = 0
    Private m_ImageAngle5 As Double = 30
    Private m_ImageAngle6 As Double = -90
    Private m_ImageAngle7 As Double = -90

    ' 첫번째 바늘 이미지
    Private imgRotate4 As Bitmap
    Private imgRotate5 As Bitmap
    Private imgRotate6 As Bitmap
    Private imgRotate6_2 As Bitmap

    ' 그림의 중심축4(좌표) 저장
    Private m_NeedleCenter4 As Point
    Private m_NeedleCenter5 As Point
    Private m_NeedleCenter6 As Point

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' -------------------- Point Rotation 관련 변수 초기화 --------------------
        ' SmartDraw의 가로/세로 사이즈
        smartDraw1.Width = Resource1.bg1.Width
        smartDraw1.Height = Resource1.bg1.Height
        smartDraw1.BackLayer.ImageDraw(Resource1.bg1, 0, 0)

        smartDraw2.Width = Resource1.bg2.Width
        smartDraw2.Height = Resource1.bg2.Height
        smartDraw2.BackLayer.ImageDraw(Resource1.bg2, 0, 0)

        smartDraw3.Width = Resource1.bg3.Width
        smartDraw3.Height = Resource1.bg3.Height
        smartDraw3.BackLayer.ImageDraw(Resource1.bg3, 0, 0)

        ' 선 또는 도형의 중심축 X,Y 좌표
        m_NeedleCenter1.X = 76
        m_NeedleCenter1.Y = 82

        m_NeedleCenter2.X = 95
        m_NeedleCenter2.Y = 87

        m_NeedleCenter3.X = 83
        m_NeedleCenter3.Y = 84

        m_NeedleCenter4.X = 65
        m_NeedleCenter4.Y = 57

        m_NeedleCenter5.X = 64
        m_NeedleCenter5.Y = 64

        m_NeedleCenter6.X = 73
        m_NeedleCenter6.Y = 73

        ' Point 배열 생성
        m_Needle1 = New Point(4) {}
        m_Needle2_1 = New Point(3) {}
        m_Needle2_2 = New Point(3) {}
        m_Needle3 = New Point(14) {}
        m_Needle4 = New Point(14) {}

        ' -------------------- Image Rotation 관련 변수 초기화 --------------------
        ' 바늘 이미지의 객체 생성
        imgRotate4 = New Bitmap(Resource1.ImgNeedle1)
        imgRotate5 = New Bitmap(Resource1.ImgNeedle2)
        imgRotate6 = New Bitmap(Resource1.ImgNeedle5_3)
        imgRotate6_2 = New Bitmap(Resource1.ImgNeedle6)

        ' -------------------- 버튼 클릭전의 게이지의 화살표 표시 --------------------
        ' 첫번째 게이지의 Polygon
        smartDraw1.SetPenStyle(Color.LimeGreen, 1)
        smartDraw1.SetBrushStyle(Color.LimeGreen)
        m_Needle1(0).X = 36
        m_Needle1(0).Y = 83
        m_Needle1(1).X = 36
        m_Needle1(1).Y = 81
        m_Needle1(2).X = 77
        m_Needle1(2).Y = 78
        m_Needle1(3).X = 77
        m_Needle1(3).Y = 86
        m_Needle1(4).X = 36
        m_Needle1(4).Y = 83
        smartDraw1.Polygon(m_Needle1)
        smartDraw1.SetPenStyle(Color.Crimson, 1)
        ' 첫번째 게이지의 외부 중심원
        smartDraw1.SetBrushStyle(Color.Crimson)
        smartDraw1.Circle(77, 83, 16)
        ' 첫번째 게이지의 외부 중심원
        smartDraw1.SetBrushStyle(Color.Pink)
        smartDraw1.Circle(77, 83, 9)

        ' 두번째 게이지의 Polygon Out
        smartDraw2.SetPenStyle(Color.Aqua, 1)
        smartDraw2.SetBrushStyle(Color.Aqua)
        m_Needle2_1(0).X = 39
        m_Needle2_1(0).Y = 120
        m_Needle2_1(1).X = 91
        m_Needle2_1(1).Y = 81
        m_Needle2_1(2).X = 97
        m_Needle2_1(2).Y = 93
        m_Needle2_1(3).X = 39
        m_Needle2_1(3).Y = 120
        smartDraw2.Polygon(m_Needle2_1)
        ' 두번째 게이지의 Polygon In
        smartDraw2.SetPenStyle(Color.White, 1)
        smartDraw2.SetBrushStyle(Color.White)
        m_Needle2_2(0).X = 88
        m_Needle2_2(0).Y = 87
        m_Needle2_2(1).X = 65
        m_Needle2_2(1).Y = 105
        m_Needle2_2(2).X = 92
        m_Needle2_2(2).Y = 92
        m_Needle2_2(3).X = 88
        m_Needle2_2(3).Y = 87
        smartDraw2.Polygon(m_Needle2_2)
        ' 2번째 게이지의 외부 중심원
        smartDraw1.SetPenStyle(Color.White, 1)
        smartDraw2.SetBrushStyle(Color.White)
        smartDraw2.Circle(95, 87, 16)

        ' 3번째 게이지의 Polygon1
        smartDraw3.SetPenStyle(Color.Red, 0)
        smartDraw3.SetBrushStyle(Color.Red)
        m_Needle3(0).X = 82
        m_Needle3(0).Y = 8
        m_Needle3(1).X = 84
        m_Needle3(1).Y = 8
        m_Needle3(2).X = 86
        m_Needle3(2).Y = 39
        m_Needle3(3).X = 87
        m_Needle3(3).Y = 39
        m_Needle3(4).X = 87
        m_Needle3(4).Y = 78
        m_Needle3(5).X = 90
        m_Needle3(5).Y = 84
        m_Needle3(6).X = 86
        m_Needle3(6).Y = 90
        m_Needle3(7).X = 86
        m_Needle3(7).Y = 98
        m_Needle3(8).X = 80
        m_Needle3(8).Y = 98
        m_Needle3(9).X = 80
        m_Needle3(9).Y = 90
        m_Needle3(10).X = 76
        m_Needle3(10).Y = 84
        m_Needle3(11).X = 79
        m_Needle3(11).Y = 78
        m_Needle3(12).X = 79
        m_Needle3(12).Y = 39
        m_Needle3(13).X = 80
        m_Needle3(13).Y = 39
        m_Needle3(14).X = 82
        m_Needle3(14).Y = 8
        smartDraw3.Polygon(m_Needle3)

        ' 3번째 게이지의 Polygon2
        smartDraw3.SetPenStyle(Color.White, 0)
        smartDraw3.SetBrushStyle(Color.White)
        m_Needle4(0).X = 82
        m_Needle4(0).Y = 30
        m_Needle4(1).X = 84
        m_Needle4(1).Y = 30
        m_Needle4(2).X = 84
        m_Needle4(2).Y = 65
        m_Needle4(3).X = 85
        m_Needle4(3).Y = 65
        m_Needle4(4).X = 85
        m_Needle4(4).Y = 78
        m_Needle4(5).X = 88
        m_Needle4(5).Y = 84
        m_Needle4(6).X = 85
        m_Needle4(6).Y = 90
        m_Needle4(7).X = 85
        m_Needle4(7).Y = 98
        m_Needle4(8).X = 81
        m_Needle4(8).Y = 98
        m_Needle4(9).X = 81
        m_Needle4(9).Y = 90
        m_Needle4(10).X = 78
        m_Needle4(10).Y = 84
        m_Needle4(11).X = 81
        m_Needle4(11).Y = 78
        m_Needle4(12).X = 81
        m_Needle4(12).Y = 65
        m_Needle4(13).X = 82
        m_Needle4(13).Y = 65
        m_Needle4(14).X = 82
        m_Needle4(14).Y = 30
        smartDraw3.Polygon(m_Needle4)

        ' 3번째 게이지의 내부 중심원
        smartDraw3.SetBrushStyle(Color.Black)
        smartDraw3.Circle(83, 84, 9)

        smartPictureBox1.ImageRotation(imgRotate4, m_NeedleCenter4.X, m_NeedleCenter4.Y, 20, 18, m_ImageAngle4)
        smartPictureBox2.ImageRotation(imgRotate5, m_NeedleCenter5.X, m_NeedleCenter5.Y, 31, 22, m_ImageAngle5)
        Dim imgBackResult As Bitmap = New Bitmap(Resource1.bg3)
        smartPictureBox3.ImageRotation(imgRotate6_2, imgBackResult, m_NeedleCenter6.X, m_NeedleCenter6.Y, 10, 10, m_ImageAngle7)
        smartPictureBox3.Image = imgBackResult

        smartPictureBox3.ImageRotation(imgRotate6, imgBackResult, m_NeedleCenter6.X, m_NeedleCenter6.Y, 10, 10, m_ImageAngle6)
        smartPictureBox3.Image = imgBackResult
    End Sub

    ' -------------------- Point Rotation Up/Down Click Event --------------------
    ' PointRotation 좌측 UpDown Button
    Private Sub btnPoint1Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPoints1_Up.Click, btnPoints1_Down.Click
        ' 이전 그려진 RotationPoints 삭제
        smartDraw1.Erase()

        If sender Is btnPoints1_Up Then
            ' Gauge가 90도에서 -90도 사이에서만 이동
            If m_dbPointAngle1 <= 90 AndAlso m_dbPointAngle1 > -90 Then
                ' 시계방향으로 30도 회전
                m_dbPointAngle1 -= 30.0
            End If
        Else
            ' Gauge가 90도에서 -90도 사이에서만 이동
            If m_dbPointAngle1 < 90 AndAlso m_dbPointAngle1 >= -90 Then
                ' 반 시계방향으로 30도 회전
                m_dbPointAngle1 += 30.0
            End If
        End If

        smartDraw1.SetPenStyle(Color.LimeGreen, 1)
        smartDraw1.SetBrushStyle(Color.LimeGreen)
        ' 입력된 여러 개의 좌표를 기준점 중심으로 설정된 각도 만큼 좌표들의 회전된 좌표를 리턴
        smartDraw1.Polygon(smartDraw1.RotationPoints(m_Needle1, m_NeedleCenter1, m_dbPointAngle1))

        ' 첫번째 게이지의 중심 외부원
        smartDraw1.SetPenStyle(Color.Crimson, 1)
        smartDraw1.SetBrushStyle(Color.Crimson)
        smartDraw1.Circle(77, 83, 16)
        ' 첫번째 게이지의 중심 내부원
        smartDraw1.SetBrushStyle(Color.Pink)
        smartDraw1.Circle(77, 83, 9)
    End Sub

    ' PointRotation 중앙 UpDown Button
    Private Sub btnPoint2Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPoints2_Up.Click, btnPoints2_Down.Click
        smartDraw2.Erase()

        If sender Is btnPoints2_Up Then
            ' Gauge가 0도에서 240도 사이에서만 이동
            If m_dbPointAngle2 <= 150 AndAlso m_dbPointAngle2 > -90 Then
                ' 시계방향으로 30도 회전
                m_dbPointAngle2 -= 30.0
            End If
        Else
            ' Gauge가 0도에서 240도 사이에서만 이동
            If m_dbPointAngle2 <= 120 AndAlso m_dbPointAngle2 >= -90 Then
                ' 반 시계방향으로 30도 회전
                m_dbPointAngle2 += 30.0
            End If
        End If

        smartDraw2.SetPenStyle(Color.Aqua, 1)
        smartDraw2.SetBrushStyle(Color.Aqua)
        smartDraw2.Polygon(smartDraw2.RotationPoints(m_Needle2_1, m_NeedleCenter2, m_dbPointAngle2))
        smartDraw2.SetBrushStyle(Color.White)
        smartDraw2.Polygon(smartDraw2.RotationPoints(m_Needle2_2, m_NeedleCenter2, m_dbPointAngle2))
        ' 2번째 게이지의 중심 외부원
        smartDraw2.SetBrushStyle(Color.White)
        smartDraw2.Circle(95, 87, 16)
    End Sub

    ' PointRotation 우측 UpDown Button
    Private Sub btnPoint3Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPoints3_Up.Click, btnPoints3_Down.Click
        smartDraw3.Erase()

        If sender Is btnPoints3_Up Then
            ' 시계방향으로 10도 회전 
            m_dbPointAngle3 -= 10.0
            ' 시계방향으로 5도 회전
            m_dbPointAngle4 -= 5.0
        Else
            ' 반 시계방향으로 10도 회전
            m_dbPointAngle3 += 10.0
            ' 반 시계방향으로 5도 회전
            m_dbPointAngle4 += 5.0
        End If

        smartDraw3.SetPenStyle(Color.Red, 0)
        smartDraw3.SetBrushStyle(Color.Red)
        smartDraw3.Polygon(smartDraw3.RotationPoints(m_Needle3, m_NeedleCenter3, m_dbPointAngle3))

        smartDraw3.SetPenStyle(Color.White, 0)
        smartDraw3.SetBrushStyle(Color.White)
        smartDraw3.Polygon(smartDraw3.RotationPoints(m_Needle4, m_NeedleCenter3, m_dbPointAngle4))

        ' 3번째 게이지의 중심 내부원
        smartDraw3.SetBrushStyle(Color.Black)
        smartDraw3.Circle(83, 84, 9)
    End Sub

    ' -------------------- Image Rotation Up/Down Click Event --------------------
    ' RotationImage 좌측 UpDown Button
    Private Sub btnImage1Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnImage1_Up.Click, btnImage1_Down.Click
        If sender Is btnImage1_Up Then
            ' Gauge가 0도에서 -180도 사이에서만 이동
            If m_ImageAngle4 <= 0 AndAlso m_ImageAngle4 > -180 Then
                ' 시계방향으로 5도 회전
                m_ImageAngle4 -= 5
            End If
        Else
            ' Gauge가 0도에서 -180도 사이에서만 이동
            If m_ImageAngle4 < 0 AndAlso m_ImageAngle4 >= -180 Then
                ' 반 시계방향으로 5도 회전 
                m_ImageAngle4 += 5
            End If
        End If

        ' 변경된 각도 만큼 Image 회전
        smartPictureBox1.ImageRotation(imgRotate4, m_NeedleCenter4.X, m_NeedleCenter4.Y, 20, 18, m_ImageAngle4)
    End Sub

    ' RotationImage 중앙 UpDown Button
    Private Sub btnImage2Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnImage2_Up.Click, btnImage2_Down.Click
        If sender Is btnImage2_Up Then
            ' Gauge가 30도에서 -210도 사이에서만 이동
            If m_ImageAngle5 <= 30 AndAlso m_ImageAngle5 > -210 Then
                ' 시계방향으로 5도 회전
                m_ImageAngle5 -= 5
            End If
        Else
            ' Gauge가 30도에서 -240도 사이에서만 이동
            If m_ImageAngle5 < 30 AndAlso m_ImageAngle5 >= -240 Then
                ' 반 시계방향으로 5도 회전 
                m_ImageAngle5 += 5
            End If
        End If

        ' 변경된 각도 만큼 Image 회전
        smartPictureBox2.ImageRotation(imgRotate5, m_NeedleCenter5.X, m_NeedleCenter5.Y, 31, 22, m_ImageAngle5)
    End Sub

    ' RotationImage 우측 UpDown Button
    Private Sub btnImage3Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnImage3_Up.Click, btnImage3_Down.Click
        If sender Is btnImage3_Up Then
            ' 시계방향으로 5도 회전 
            m_ImageAngle6 -= 5
            ' 시계방향으로 10도 회전 
            m_ImageAngle7 -= 10
        Else
            ' 반 시계방향으로 5도 회전 
            m_ImageAngle6 += 5
            ' 반 시계방향으로 10도 회전 
            m_ImageAngle7 += 10
        End If

        Dim imgBackResult As Bitmap = New Bitmap(Resource1.bg3)

        ' 변경된 각도 만큼 Image 회전 (흰색 Needle)
        smartPictureBox3.ImageRotation(imgRotate6_2, imgBackResult, m_NeedleCenter6.X, m_NeedleCenter6.Y, 10, 10, m_ImageAngle7)
        smartPictureBox3.Image = imgBackResult

        ' 변경된 각도 만큼 Image 회전 (빨간색 Needle)
        smartPictureBox3.ImageRotation(imgRotate6, imgBackResult, m_NeedleCenter6.X, m_NeedleCenter6.Y, 10, 10, m_ImageAngle6)
        smartPictureBox3.Image = imgBackResult
    End Sub
End Class
